# cern-lxdistcc-wrappers: v46 2011/05/09 KELEMEN Peter <Peter.Kelemen@cern.ch>

%{!?dist: %define dist .slc6}
%define debug_package %{nil}

Name: cern-lxdistcc-wrappers
Version: 1
Release: 16%{dist}
Summary: CERN lxdistcc compiler wrappers
Group: Development/Languages
License: GPL
Vendor: CERN
Packager: lxdistcc-admins@cern.ch
URL: https://twiki.cern.ch/twiki/bin/view/LinuxSupport/DistccPilotService
BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot
BuildArch: x86_64

%define	_prefix	/usr
%define _bindir %{_prefix}/bin

Requires: openafs-client >= 1.4.8-8.cern
Obsoletes: cern-lxdistcc-lcg

%description 
CERN lxdistcc compiler wrappers for %{dist}.%{buildarch}

%prep
%setup -cT

cat > %{name}.sh <<EOT
#!/bin/sh
# %{name}.sh: v1 KELEMEN Peter <%{packager}>
_self=\${0##*/}

setup_env () {
	_version=\${_self##*-}
	_platform=\${_platform:-x86_64-slc6}
        _product=\${_product:-gcc}

	_prefix="/afs/cern.ch/sw/lcg/external/\${_product}/\${_version}"
	_bin="\${_prefix}/\${_platform}/bin"
	_lib="\${_prefix}/\${_platform}/lib64"
	LD_LIBRARY_PATH="\${_lib}\${LD_LIBRARY_PATH:+:}\${LD_LIBRARY_PATH}"
	PATH="\${_bin}\${PATH:+:}\${PATH}"

	export LD_LIBRARY_PATH
	export PATH
}

case \${_self} in

%if "%{dist}" == ".slc4"
	lcg-*-4.3.2)
		_platform=slc4_amd64
		setup_env
		;;
%endif

%if "%{dist}" == ".slc5"
        lcg-*-3.2)
		_product=llvm
 		_platform=x86_64-slc5
		setup_env
   		LD_LIBRARY_PATH="/afs/cern.ch/sw/lcg/external/gcc/4.6.3/x86_64-slc5/lib64\${LD_LIBRARY_PATH:+:}\${LD_LIBRARY_PATH}"
                ;;
	lcg-*-4.3.2|lcg-*-4.3.5|lcg-*-4.3.6|lcg-*-4.5.2|lcg-*-4.6.2|lcg-*-4.6.3|lcg-*-4.7.2|lcg-*-4.8.0)
		_platform=x86_64-slc5
		setup_env
		;;
%endif

%if "%{dist}" == ".slc6"
        lcg-*-3.2)
		_product=llvm
                setup_env
   		LD_LIBRARY_PATH="/afs/cern.ch/sw/lcg/external/gcc/4.6.3/x86_64-slc6/lib64\${LD_LIBRARY_PATH:+:}\${LD_LIBRARY_PATH}"
                ;;
        lcg-*-4.3.5|lcg-*-4.3.6|lcg-*-4.5.3|lcg-*-4.6.2|lcg-*-4.6.3|lcg-*-4.7.2|lcg-*-4.8.0)
		
                setup_env
                ;;
%endif

	*)
		echo "E: Unsupported compiler '\${_self}', please contact <%{packager}>"
		exit 100
		;;
esac

\${_bin}/\${_self} "\$@"
exit \$?

# End of file.
EOT

%build

%install
rm -rf ${RPM_BUILD_ROOT}
install -m 755 -d ${RPM_BUILD_ROOT}/%{_bindir}
install -m 755 %{name}.sh ${RPM_BUILD_ROOT}/%{_bindir}
cd ${RPM_BUILD_ROOT}/%{_bindir}
%if "%{dist}" == ".slc4"
ln -s %{name}.sh lcg-gcc-4.3.2
ln -s %{name}.sh lcg-g++-4.3.2
ln -s %{name}.sh lcg-c++-4.3.2
%endif
%if "%{dist}" == ".slc5"
ln -s %{name}.sh lcg-gcc-4.3.2
ln -s %{name}.sh lcg-g++-4.3.2
ln -s %{name}.sh lcg-c++-4.3.2
ln -s %{name}.sh lcg-gcc-4.3.5
ln -s %{name}.sh lcg-g++-4.3.5
ln -s %{name}.sh lcg-c++-4.3.5
ln -s %{name}.sh lcg-gcc-4.3.6
ln -s %{name}.sh lcg-g++-4.3.6
ln -s %{name}.sh lcg-c++-4.3.6
ln -s %{name}.sh lcg-gcc-4.5.2
ln -s %{name}.sh lcg-g++-4.5.2
ln -s %{name}.sh lcg-c++-4.5.2
ln -s %{name}.sh lcg-gcc-4.6.2
ln -s %{name}.sh lcg-g++-4.6.2
ln -s %{name}.sh lcg-c++-4.6.2
ln -s %{name}.sh lcg-gcc-4.6.3
ln -s %{name}.sh lcg-g++-4.6.3
ln -s %{name}.sh lcg-c++-4.6.3
ln -s %{name}.sh lcg-gcc-4.7.2
ln -s %{name}.sh lcg-g++-4.7.2
ln -s %{name}.sh lcg-c++-4.7.2
ln -s %{name}.sh lcg-gcc-4.8.0
ln -s %{name}.sh lcg-g++-4.8.0
ln -s %{name}.sh lcg-c++-4.8.0
ln -s %{name}.sh lcg-clang-3.2
ln -s %{name}.sh lcg-clang++-3.2
%endif
%if "%{dist}" == ".slc6"
ln -s %{name}.sh lcg-gcc-4.3.5
ln -s %{name}.sh lcg-g++-4.3.5
ln -s %{name}.sh lcg-c++-4.3.5
ln -s %{name}.sh lcg-gcc-4.3.6
ln -s %{name}.sh lcg-g++-4.3.6
ln -s %{name}.sh lcg-c++-4.3.6
ln -s %{name}.sh lcg-gcc-4.5.3
ln -s %{name}.sh lcg-g++-4.5.3
ln -s %{name}.sh lcg-c++-4.5.3
ln -s %{name}.sh lcg-gcc-4.6.2
ln -s %{name}.sh lcg-g++-4.6.2
ln -s %{name}.sh lcg-c++-4.6.2
ln -s %{name}.sh lcg-gcc-4.6.3
ln -s %{name}.sh lcg-g++-4.6.3
ln -s %{name}.sh lcg-c++-4.6.3
ln -s %{name}.sh lcg-gcc-4.7.2
ln -s %{name}.sh lcg-g++-4.7.2
ln -s %{name}.sh lcg-c++-4.7.2
ln -s %{name}.sh lcg-gcc-4.8.0
ln -s %{name}.sh lcg-g++-4.8.0
ln -s %{name}.sh lcg-c++-4.8.0
ln -s %{name}.sh lcg-clang-3.2
ln -s %{name}.sh lcg-clang++-3.2
%endif


%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%{_bindir}/%{name}.sh
%{_bindir}/lcg-*

%post
/sbin/service distcc condrestart >/dev/null 2>&1 ||:

%postun
if [ "$1" = "0" ]; then # this is an uninstallation
    /sbin/service distcc condrestart >/dev/null 2>&1 ||:
fi

%changelog
* Mon Jun 10 2013 Jan van Eldik <lxdistcc-admins@cern.ch> 1-16
- SLC5, SLC6: add support for LLVM compilers [RQF0226010]

* Thu May  2 2013 Jan van Eldik <lxdistcc-admins@cern.ch> 1-15
- SLC5: support lcg-*-4.6.3 compilers
- SLC5, SLC6: prepare support for LLVM compilers

* Mon Apr 22 2013 Jan van Eldik <lxdistcc-admins@cern.ch> 1-14
- SLC5, SLC6: support lcg-*-4.8.0 compilers

* Tue Nov  6 2012 Jan van Eldik <lxdistcc-admins@cern.ch> 1-13
- SLC6: support lcg-*-4.6.3 compilers

* Tue Nov  6 2012 Jan van Eldik <lxdistcc-admins@cern.ch> 1-12
- SLC5,SLC6: support lcg-*-4.7.2 compilers

* Mon Oct  8 2012 Jan van Eldik <lxdistcc-admins@cern.ch> 1-11
- Oops.

* Fri Oct  5 2012 Jan van Eldik <lxdistcc-admins@cern.ch> 1-10
- SLC5,SLC6: support lcg-*-4.3.6 compilers

* Tue May  8 2012 Jan van Eldik <lxdistcc-admins@cern.ch> 1-9
- Oops.

* Thu May  3 2012 Jan van Eldik <lxdistcc-admins@cern.ch> 1-8
- add conditional restart's to RPM scriptlets

* Fri Apr 27 2012 Jan van Eldik <lxdistcc-admins@cern.ch> 1-7
- SLC6: support lcg-*-4.3.5 compilers

* Tue Dec 13 2011 Jan van Eldik <lxdistcc-admins@cern.ch> 1-6
- SLC6: support lcg-*-4.5.3 and lcg-*-4.6.2 compilers

* Tue Dec 13 2011 Jaroslaw Polok <lxdistcc-admins@cern.ch> 1-5
- updated build for 4/5/6
- adding compilers on slc6

* Mon Oct 24 2011 Jaroslaw Polok <lxdistcc-admins@cern.ch> 1-4
- first build for SLC6

* Mon May 16 2011  KELEMEN Peter <lxdistcc-admins@cern.ch> 1-3
- dropped Requires: distcc-server, we need the wrappers installed on both client/server

* Mon May  9 2011  KELEMEN Peter <lxdistcc-admins@cern.ch> 1-2
- dropped Conflicts:
- added Requires: distcc-server

* Mon May  9 2011  KELEMEN Peter <lxdistcc-admins@cern.ch> 1-1
- renamed package to cern-lxdistcc-wrappers
- support for LCG compiler versions: 4.3.2, 4.3.5, 4.5.2
